Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(copie de travail)
@@ -2407,66 +2892,322 @@
 	pN.removeChild(el);
 	return el;
 };
-
-String.prototype.trim = function() {
-	return this.replace(/^\s+/, '').replace(/\s+$/, '');
-};
-
-// creates a rgb-style color from a number
-HTMLArea._makeColor = function(v) {
-	if (typeof(v) != "number") {
-		// already in rgb (hopefully); IE doesn't get here.
-		return v;
+/***************************************************
+ *  TIPS ON FORM FIELDS AND MENU ITEMS
+ ***************************************************/
+/*
+ * Intercept Ext.form.Field.afterRender in order to provide tips on form fields and menu items
+ * Adapted from: http://www.extjs.com/forum/showthread.php?t=36642
+ */
+HTMLArea.util.Tips = function () {
+	return {
+		tipsOnFormFields: function () {
+			if (this.helpText || this.helpTitle) {
+				if (!this.helpDisplay) {
+					this.helpDisplay = 'both';
+				}
+				var label = this.label;
+					// IE has problems with img inside label tag
+				if (label && this.helpIcon && !Ext.isIE) {
+					var helpImage = label.insertFirst({
+						tag: 'img',
+						src: _editor_skin + 'images/helpbubble.gif',
+						style: 'vertical-align: middle; padding-right: 2px;'
+					});
+					if (this.helpDisplay == 'image' || this.helpDisplay == 'both'){
+						Ext.QuickTips.register({
+							target: helpImage,
+							title: this.helpTitle,
+							text: this.helpText
+						});
+					}
+				}
+				if (this.helpDisplay == 'field' || this.helpDisplay == 'both'){
+					Ext.QuickTips.register({
+						target: this,
+						title: this.helpTitle,
+						text: this.helpText
+					});
+				}
+			}
+		},
+		tipsOnMenuItems: function () {
+			if (this.helpText || this.helpTitle) {
+				Ext.QuickTips.register({
+					target: this,
+					title: this.helpTitle,
+					text: this.helpText
+				});
+			}
+		}
 	}
-	// IE sends number; convert to rgb.
-	var r = v & 0xFF;
-	var g = (v >> 8) & 0xFF;
-	var b = (v >> 16) & 0xFF;
-	return "rgb(" + r + "," + g + "," + b + ")";
-};
-
-// returns hexadecimal color representation from a number or a rgb-style color.
-HTMLArea._colorToRgb = function(v) {
-	if (!v)
-		return '';
-
-	// returns the hex representation of one byte (2 digits)
-	function hex(d) {
-		return (d < 16) ? ("0" + d.toString(16)) : d.toString(16);
-	};
-
-	if (typeof(v) == "number") {
-		// we're talking to IE here
-		var r = v & 0xFF;
-		var g = (v >> 8) & 0xFF;
-		var b = (v >> 16) & 0xFF;
-		return "#" + hex(r) + hex(g) + hex(b);
+}();
+Ext.form.Field.prototype.afterRender = Ext.form.Field.prototype.afterRender.createInterceptor(HTMLArea.util.Tips.tipsOnFormFields);
+Ext.menu.BaseItem.prototype.afterRender = Ext.menu.BaseItem.prototype.afterRender.createInterceptor(HTMLArea.util.Tips.tipsOnMenuItems);
+/***************************************************
+ *  COLOR WIDGETS AND UTILITIES
+ ***************************************************/
+HTMLArea.util.Color = function () {
+	return {
+		/*
+		 * Returns a rgb-style color from a number
+		 */
+		colorToRgb: function(v) {
+			if (typeof(v) != 'number') {
+				return v;
+			}
+			var r = v & 0xFF;
+			var g = (v >> 8) & 0xFF;
+			var b = (v >> 16) & 0xFF;
+			return 'rgb(' + r + ',' + g + ',' + b + ')';
+		},
+		/*
+		 * Returns hexadecimal color representation from a number or a rgb-style color.
+		 */
+		colorToHex: function(v) {
+			if (!v) {
+				return '';
+			}
+			function hex(d) {
+				return (d < 16) ? ('0' + d.toString(16)) : d.toString(16);
+			};
+			if (typeof(v) == 'number') {
+				var r = v & 0xFF;
+				var g = (v >> 8) & 0xFF;
+				var b = (v >> 16) & 0xFF;
+				return '#' + hex(r) + hex(g) + hex(b);
+			}
+			if (v.substr(0, 3) === 'rgb') {
+				var re = /rgb\s*\(\s*([0-9]+)\s*,\s*([0-9]+)\s*,\s*([0-9]+)\s*\)/;
+				if (v.match(re)) {
+					var r = parseInt(RegExp.$1);
+					var g = parseInt(RegExp.$2);
+					var b = parseInt(RegExp.$3);
+					return ('#' + hex(r) + hex(g) + hex(b)).toUpperCase();
+				}
+				return null;
+			}
+			if (v.substr(0, 1) === '#') {
+				return v;
+			}
+			return null;
+		},
+		/*
+		 * Select interceptor to ensure that the color exists in the palette before trying to select
+		 */
+		checkIfColorInPalette: function (color) {
+				// Do not continue if the new color is not in the palette
+			if (this.el && !this.el.child('a.color-' + color)) {
+					// Remove any previous selection
+				this.deSelect();
+				return false;
+			}
+		}
 	}
-
-	if (v.substr(0, 3) == "rgb") {
-		// in rgb(...) form -- Mozilla
-		var re = /rgb\s*\(\s*([0-9]+)\s*,\s*([0-9]+)\s*,\s*([0-9]+)\s*\)/;
-		if (v.match(re)) {
-			var r = parseInt(RegExp.$1);
-			var g = parseInt(RegExp.$2);
-			var b = parseInt(RegExp.$3);
-			return "#" + hex(r) + hex(g) + hex(b);
+}();
+/*
+ * Interim backward compatibility
+ */
+HTMLArea._makeColor = HTMLArea.util.Color.colorToRgb;
+HTMLArea._colorToRgb = HTMLArea.util.Color.colorToHex;
+/*
+ * Intercept Ext.ColorPalette.prototype.select
+ */
+Ext.ColorPalette.prototype.select = Ext.ColorPalette.prototype.select.createInterceptor(HTMLArea.util.Color.checkIfColorInPalette);
+/*
+ * Add deSelect method to Ext.ColorPalette
+ */
+Ext.override(Ext.ColorPalette, {
+	deSelect: function () {
+		if (this.el && this.value){
+			this.el.child('a.color-' + this.value).removeClass('x-color-palette-sel');
+			this.value = null;
 		}
-		// doesn't match RE?!  maybe uses percentages or float numbers
-		// -- FIXME: not yet implemented.
-		return null;
 	}
-
-	if (v.substr(0, 1) == "#") {
-		// already hex rgb (hopefully :D )
-		return v;
+});
+Ext.ux.menu.HTMLAreaColorMenu = Ext.extend(Ext.menu.Menu, {
+	enableScrolling: false,
+	hideOnClick: true,
+	cls: 'x-color-menu',
+	colorPaletteValue: '',
+	customColorsValue: '',
+	plain: true,
+	showSeparator: false,
+	initComponent: function () {
+		var paletteItems = [];
+		var width = 'auto';
+		if (this.colorsConfiguration) {
+			paletteItems.push({
+				xtype: 'container',
+				layout: 'anchor',
+				width: 160,
+				style: { float: 'right' },
+				items: {
+					xtype: 'colorpalette',
+					itemId: 'custom-colors',
+					cls: 'htmlarea-custom-colors',
+					colors: this.colorsConfiguration,
+					value: this.value,
+					allowReselect: true,
+					tpl: new Ext.XTemplate(
+						'<tpl for="."><a href="#" class="color-{1}" hidefocus="on"><em><span style="background:#{1}" unselectable="on">&#160;</span></em><span unselectable="on">{0}<span></a></tpl>'
+					)
+				}
+			});
+			width = 350;
+		}
+		paletteItems.push({
+			xtype: 'container',
+			layout: 'anchor',
+			items: {
+				xtype: 'colorpalette',
+				itemId: 'color-palette',
+				cls: 'color-palette',
+				colors: this.colors,
+				value: this.value,
+				allowReselect: true
+			}
+		});
+		Ext.apply(this, {
+			layout: 'menu',
+			width: width,
+			items: paletteItems
+		});
+		Ext.ux.menu.HTMLAreaColorMenu.superclass.initComponent.call(this);
+		this.standardPalette = this.find('itemId', 'color-palette')[0];
+		this.customPalette = this.find('itemId', 'custom-colors')[0];
+		if (this.standardPalette) {
+			this.standardPalette.purgeListeners();
+			this.relayEvents(this.standardPalette, ['select']);
+		}
+		if (this.customPalette) {
+			this.customPalette.purgeListeners();
+			this.relayEvents(this.customPalette, ['select']);
+		}
+		this.on('select', this.menuHide, this);
+		if (this.handler){
+			this.on('select', this.handler, this.scope || this);
+		}
+	},
+	menuHide: function() {
+		if (this.hideOnClick){
+			this.hide(true);
+		}
 	}
-
-	// if everything else fails ;)
-	return null;
-};
-
+});
+Ext.reg('htmlareacolormenu', Ext.ux.menu.HTMLAreaColorMenu);
 /*
+ * Color palette trigger field
+ * Based on http://www.extjs.com/forum/showthread.php?t=89312
+ */
+Ext.ux.form.ColorPaletteField = Ext.extend(Ext.form.TriggerField, {
+	triggerClass : 'x-form-color-trigger',
+	colors : [
+		'000000', '222222', '444444', '666666', '999999', 'BBBBBB', 'DDDDDD', 'FFFFFF',
+		'660000', '663300', '996633', '003300', '003399', '000066', '330066', '660066',
+		'990000', '993300', 'CC9900', '006600', '0033FF', '000099', '660099', '990066',
+		'CC0000', 'CC3300', 'FFCC00', '009900', '0066FF', '0000CC', '663399', 'CC0099',
+		'FF0000', 'FF3300', 'FFFF00', '00CC00', '0099FF', '0000FF', '9900CC', 'FF0099',
+		'CC3333', 'FF6600', 'FFFF33', '00FF00', '00CCFF', '3366FF', '9933FF', 'FF00FF',
+		'FF6666', 'FF6633', 'FFFF66', '66FF66', '00FFFF', '3399FF', '9966FF', 'FF66FF',
+		'FF9999', 'FF9966', 'FFFF99', '99FF99', '99FFFF', '66CCFF', '9999FF', 'FF99FF',
+		'FFCCCC', 'FFCC99', 'FFFFCC', 'CCFFCC', 'CCFFFF', '99CCFF', 'CCCCFF', 'FFCCFF'
+	],
+		// Whether or not the field background, text, or triggerbackgroud are set to the selected color
+	colorizeFieldBackgroud: true,
+	colorizeFieldText: true,
+	colorizeTrigger: false,
+	editable: true,
+	initComponent: function () {
+		Ext.ux.form.ColorPaletteField.superclass.initComponent.call(this);
+		this.addEvents(            
+			'select'
+		);
+	},
+		// private
+	validateBlur: function () {
+		return !this.menu || !this.menu.isVisible();
+	},
+	setValue: function (color) {
+		if (color) {
+			if (this.colorizeFieldBackgroud) {
+				this.el.applyStyles('background: #' + color  + ';');
+			}
+			if (this.colorizeFieldText) {
+				this.el.applyStyles('color: #' + this.rgbToHex(this.invert(this.hexToRgb(color)))  + ';');
+			}
+			if (this.colorizeTrigger) {
+				this.trigger.applyStyles('background-color: #' + color  + ';');
+			}
+		}
+		return Ext.ux.form.ColorPaletteField.superclass.setValue.call(this, color);
+	},
+		// private
+	onDestroy: function () {
+		Ext.destroy(this.menu);
+		Ext.ux.form.ColorPaletteField.superclass.onDestroy.call(this);
+	},
+		// private
+	onTriggerClick: function () {
+		if (this.disabled) {
+			return;
+		}
+		if (this.menu == null) {
+			this.menu = new Ext.ux.menu.HTMLAreaColorMenu({
+				hideOnClick: false,
+				colors: this.colors,
+				colorsConfiguration: this.colorsConfiguration,
+				value: this.getValue()
+			});
+		}
+		this.onFocus();
+		this.menu.show(this.el, "tl-bl?");
+		this.menuEvents('on');
+	},
+		//private
+	menuEvents: function (method) {
+		this.menu[method]('select', this.onSelect, this);
+		this.menu[method]('hide', this.onMenuHide, this);
+		this.menu[method]('show', this.onFocus, this);
+	},
+	onSelect: function (m, d) {
+		this.setValue(d);
+		this.fireEvent('select', this, d);
+		this.menu.hide();
+	},
+	onMenuHide: function () {
+		this.focus(false, 60);
+		this.menuEvents('un');
+	},
+	invert: function ( r, g, b ) {
+		if( r instanceof Array ) { return this.invert.call( this, r[0], r[1], r[2] ); }
+		return [255-r,255-g,255-b];
+	},
+	hexToRgb: function ( hex ) {
+		return [ this.hexToDec( hex.substr(0, 2) ), this.hexToDec( hex.substr(2, 2) ), this.hexToDec( hex.substr(4, 2) ) ];
+	},
+	hexToDec: function( hex ) {
+		var s = hex.split('');
+		return ( ( this.getHCharPos( s[0] ) * 16 ) + this.getHCharPos( s[1] ) );
+	},
+	getHCharPos: function( c ) {
+		var HCHARS = '0123456789ABCDEF';
+		return HCHARS.indexOf( c.toUpperCase() );
+	},
+	rgbToHex: function( r, g, b ) {
+		if( r instanceof Array ) { return this.rgbToHex.call( this, r[0], r[1], r[2] ); }
+		return this.decToHex( r ) + this.decToHex( g ) + this.decToHex( b );
+	},
+	decToHex: function( n ) {
+		var HCHARS = '0123456789ABCDEF';
+		n = parseInt(n, 10);
+		n = ( !isNaN( n )) ? n : 0;
+		n = (n > 255 || n < 0) ? 0 : n;
+		return HCHARS.charAt( ( n - n % 16 ) / 16 ) + HCHARS.charAt( n % 16 );
+	}
+});
+Ext.reg('colorpalettefield', Ext.ux.form.ColorPaletteField);
+/*
  * Use XML HTTPRequest to post some data back to the server and do something
  * with the response (asyncronously or syncronously); this is used by such things as the spellchecker update personal dict function
  */
@@ -2555,107 +3296,39 @@
  * TYPO3-SPECIFIC FUNCTIONS
  ***************************************************/
 /*
- * Set the size of textarea with the RTE. It's called, if we are in fullscreen-mode.
- */
-var setRTEsizeByJS = function(divId, height, width) {
-	if (HTMLArea.is_gecko) height = height - 25;
-		else height = height - 60;
-	if (height > 0) document.getElementById(divId).style.height =  height + "px";
-	if (HTMLArea.is_gecko) width = "99%";
-		else width = "97%";
-	document.getElementById(divId).style.width = width;
-};
-
-/*
  * Extending the TYPO3 Lorem Ipsum extension
  */
 var lorem_ipsum = function(element,text) {
 	if (element.tagName.toLowerCase() == "textarea" && element.id && element.id.substr(0,7) == "RTEarea") {
 		var editor = RTEarea[element.id.substr(7, element.id.length)]["editor"];
 		editor.insertHTML(text);
-		editor.updateToolbar();
+		editor.toolbar.update();
 	}
 };
-
 /*
- * Initialize the editor, configure the toolbar, setup the plugins, etc.
+ * Create the editor when HTMLArea is loaded and when Ext is ready
  */
-HTMLArea.initTimer = new Object();
-
-HTMLArea.onGenerateHandler = function(editorNumber) {
-	return (function() {
-		document.getElementById('pleasewait' + editorNumber).style.display = 'none';
-		document.getElementById('editorWrap' + editorNumber).style.visibility = 'visible';
-		editorNumber = null;
-	});
-};
-
 HTMLArea.initEditor = function(editorNumber) {
-	if (document.getElementById('pleasewait' + editorNumber))	{
-	if(HTMLArea.checkSupportedBrowser()) {
-		document.getElementById('pleasewait' + editorNumber).style.display = 'block';
-		document.getElementById('editorWrap' + editorNumber).style.visibility = 'hidden';
-		if(HTMLArea.initTimer[editorNumber]) window.clearTimeout(HTMLArea.initTimer[editorNumber]);
-		if(!HTMLArea.is_loaded) {
-			HTMLArea.initTimer[editorNumber] = window.setTimeout("HTMLArea.initEditor(\'" + editorNumber + "\');", 150);
+	if (document.getElementById('pleasewait' + editorNumber)) {
+		if (HTMLArea.checkSupportedBrowser()) {
+			document.getElementById('pleasewait' + editorNumber).style.display = 'block';
+			document.getElementById('editorWrap' + editorNumber).style.visibility = 'hidden';
+			if (!HTMLArea.is_loaded) {
+				HTMLArea.initEditor.defer(150, null, [editorNumber]);
+			} else {
+					// Create an editor for the textarea
+				HTMLArea._appendToLog("[HTMLArea::initEditor]: Initializing editor with editor Id: " + editorNumber + ".");
+				var editor = new HTMLArea.Editor(Ext.apply(new HTMLArea.Config(editorNumber), RTEarea[editorNumber]));
+				editor.generate();
+				return false;
+			}
 		} else {
-			var RTE = RTEarea[editorNumber];
-			HTMLArea._appendToLog("[HTMLArea::initEditor]: Initializing editor with editor Id: " + editorNumber + ".");
-
-				// Get the configuration properties
-			var config = new HTMLArea.Config();
-			for (var property in RTE) {
-				if (RTE.hasOwnProperty(property)) {
-					config[property] = RTE[property] ? RTE[property] : false;
-				}
-			}
-				// Create an editor for the textarea
-			var editor = new HTMLArea(RTE.id, config);
-			RTE.editor = editor;
-
-				// Save the editornumber in the object
-			editor._typo3EditerNumber = editorNumber;
-			editor._editorNumber = editorNumber;
-
-				// Override these settings if they were ever modified
-			editor.config.width = "auto";
-			editor.config.height = "auto";
-			editor.config.sizeIncludesToolbar = true;
-			editor.config.fullPage = false;
-
-				// All nested tabs and inline levels in the sorting order they were applied
-			editor.nested = {};
-			editor.nested.all = RTEarea[editorNumber].tceformsNested;
-			editor.nested.sorted = HTMLArea.simplifyNested(editor.nested.all);
-
-				// Register the plugins included in the configuration
-			for (var plugin in editor.config.plugin) {
-				if (editor.config.plugin.hasOwnProperty(plugin) && editor.config.plugin[plugin]) {
-					editor.registerPlugin(plugin);
-				}
-			}
-
-			editor.onGenerate = HTMLArea.onGenerateHandler(editorNumber);
-
-			editor.generate();
-			return false;
+			document.getElementById('pleasewait' + editorNumber).style.display = 'none';
+			document.getElementById('editorWrap' + editorNumber).style.visibility = 'visible';
 		}
-	} else {
-		document.getElementById('pleasewait' + editorNumber).style.display = 'none';
-		document.getElementById('editorWrap' + editorNumber).style.visibility = 'visible';
 	}
-	}
 };
 
-HTMLArea.allElementsAreDisplayed = function(elements) {
-	for (var i=0, length=elements.length; i < length; i++) {
-		if (document.getElementById(elements[i]).style.display == "none") {
-			return false;
-		}
-	}
-	return true;
-};
-
 /**
  *	Base, version 1.0.2
  *	Copyright 2006, Dean Edwards
@@ -2754,7 +3427,7 @@
 	// single instance
 	var object = constructor ? klass : _prototype;
 	// class initialisation
-	if (object.init instanceof Function) object.init();
+	//if (object.init instanceof Function) object.init();
 	return object;
 };
 
@@ -2781,7 +3454,7 @@
 	 */
 	constructor : function(editor, pluginName) {
 		this.editor = editor;
-		this.editorNumber = editor._editorNumber;
+		this.editorNumber = editor.editorId;
 		this.editorConfiguration = editor.config;
 		this.name = pluginName;
 		try {
@@ -2854,7 +3527,7 @@
 	 * @return	object		the plugin object or null
 	 */
 	getPluginInstance : function(pluginName) {
-		return this.editor.getPluginInstance(pluginName);
+		return this.editor.getPlugin(pluginName);
 	},
 
 	/**
@@ -2863,7 +3536,7 @@
 	 * @return	string		editor mode
 	 */
 	getEditorMode : function() {
-		return this.getPluginInstance("EditorMode").getEditorMode();
+		return this.editor.getMode();
 	},
 
 	/**
@@ -2874,52 +3547,70 @@
 	 * @return	boolean		true if the button is enabled in the toolbar configuration
 	 */
 	isButtonInToolbar : function(buttonId) {
-		var toolbar = this.editorConfiguration.toolbar;
-		var n = toolbar.length;
-		for ( var i = 0; i < n; ++i ) {
-			var buttonInToolbar = new RegExp( "^(" + toolbar[i].join("|") + ")$", "i");
-			if (buttonInToolbar.test(buttonId)) {
-				return true;
-			}
-		}
-		return false;
+		var index = -1;
+		Ext.each(this.editorConfiguration.toolbar, function (row) {
+			Ext.each(row, function (group) {
+				index = group.indexOf(buttonId);
+				return index === -1;
+			});
+			return index === -1;
+		});
+		return index !== -1;
 	},
 
 	/**
-	 * Registors a button for inclusion in the toolbar
+	 * Returns the button object from the toolbar
 	 *
+	 * @param	string		buttonId: identification of the button
+	 *
+	 * @return	object		the toolbar button object
+	 */
+	getButton: function(buttonId) {
+		return this.editor.toolbar.getButton(buttonId);
+	},
+
+	/**
+	 * Arrays of ExtJS config properties that may be used on a button or dropdown in Page TSConfig
+	 */
+	ExtJSProperties: {
+		htmlareabutton: [],
+		htmlareacombo: ['width', 'listWidth', 'maxHeight' ]
+	},
+
+	/**
+	 * Registers a button for inclusion in the toolbar
+	 *
 	 * @param	object		buttonConfiguration: the configuration object of the button:
 	 *					id		: unique id for the button
 	 *					tooltip		: tooltip for the button
 	 *					textMode	: enable in text mode
 	 *					action		: name of the function invoked when the button is pressed
 	 *					context		: will be disabled if not inside one of listed elements
-	 *					hide		: hide in menu and show only in context menu?
-	 *					selection	: will be disabled if there is no selection?
+	 *					hide		: hide in menu and show only in context menu (deprecated, use hidden)
+	 *					hidden		: synonym of hide
+	 *					selection	: will be disabled if there is no selection
 	 *					hotkey		: hotkey character
 	 *					dialog		: if true, the button opens a dialogue
 	 *					dimensions	: the opening dimensions object of the dialogue window
 	 *
 	 * @return	boolean		true if the button was successfully registered
 	 */
-	registerButton : function (buttonConfiguration) {
+	registerButton: function (buttonConfiguration) {
 		if (this.isButtonInToolbar(buttonConfiguration.id)) {
-			if ((typeof(buttonConfiguration.action) === "string") && (typeof(this[buttonConfiguration.action]) === "function")) {
-				var hotKeyAction = buttonConfiguration.action;
-				var actionFunctionReference = this.makeFunctionReference(buttonConfiguration.action);
-				buttonConfiguration.action = actionFunctionReference;
-				if (!buttonConfiguration.textMode) {
-					buttonConfiguration.textMode = false;
-				}
+			if (Ext.isString(buttonConfiguration.action) && Ext.isFunction(this[buttonConfiguration.action])) {
+				buttonConfiguration.plugins = this;
 				if (buttonConfiguration.dialog) {
 					if (!buttonConfiguration.dimensions) {
 						buttonConfiguration.dimensions = { width: 250, height: 250};
 					}
 					buttonConfiguration.dimensions.top = buttonConfiguration.dimensions.top ?  buttonConfiguration.dimensions.top : this.editorConfiguration.dialogueWindows.defaultPositionFromTop;
 					buttonConfiguration.dimensions.left = buttonConfiguration.dimensions.left ?  buttonConfiguration.dimensions.left : this.editorConfiguration.dialogueWindows.defaultPositionFromLeft;
-				} else {
-					buttonConfiguration.dialog = false;
 				}
+				buttonConfiguration.hidden = buttonConfiguration.hide;
+					// Copy ExtJS properties for the button
+				if (this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonConfiguration.id]]) {
+					buttonConfiguration = Ext.copyTo(buttonConfiguration, this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonConfiguration.id]], this.ExtJSProperties['htmlareabutton']);
+				}
 				if (this.editorConfiguration.registerButton(buttonConfiguration)) {
 					var hotKey = buttonConfiguration.hotKey ? buttonConfiguration.hotKey :
 						((this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonConfiguration.id]] && this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonConfiguration.id]].hotKey) ? this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonConfiguration.id]].hotKey : null);
@@ -2932,8 +3623,7 @@
 					if (hotKey || hotKey == "0") {
 						var hotKeyConfiguration = {
 							id	: hotKey,
-							cmd	: buttonConfiguration.id,
-							action	: hotKeyAction
+							cmd	: buttonConfiguration.id
 						};
 						return this.registerHotKey(hotKeyConfiguration);
 					}
@@ -2945,44 +3635,52 @@
 		}
 		return false;
 	},
-
 	/**
-	 * Registors a drop-down list for inclusion in the toolbar
+	 * Registers a drop-down list for inclusion in the toolbar
 	 *
 	 * @param	object		dropDownConfiguration: the configuration object of the drop-down:
 	 *					id		: unique id for the drop-down
 	 *					tooltip		: tooltip for the drop-down
+	 *					action		: name of function to invoke when an option is selected
 	 *					textMode	: enable in text mode
-	 *					action		: name of the function invoked when a new option is selected
-	 *					refresh		: name of the function invoked in order to refresh the drop-down when the toolbar is updated
-	 *					context		: will be disabled if not inside one of listed elements
 	 *
 	 * @return	boolean		true if the drop-down list was successfully registered
 	 */
-	registerDropDown : function (dropDownConfiguration) {
+	registerDropDown: function (dropDownConfiguration) {
 		if (this.isButtonInToolbar(dropDownConfiguration.id)) {
-			if (typeof((dropDownConfiguration.action) === "string") && (typeof(this[dropDownConfiguration.action]) === "function")) {
-				var actionFunctionReference = this.makeFunctionReference(dropDownConfiguration.action);
-				dropDownConfiguration.action = actionFunctionReference;
-				if (!dropDownConfiguration.textMode) {
-					dropDownConfiguration.textMode = false;
+			if (Ext.isString(dropDownConfiguration.action) && Ext.isFunction(this[dropDownConfiguration.action])) {
+				dropDownConfiguration.plugins = this;
+				dropDownConfiguration.hidden = dropDownConfiguration.hide;
+				dropDownConfiguration.xtype = 'htmlareacombo';
+				if (this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[dropDownConfiguration.id]]) {
+					dropDownConfiguration = Ext.copyTo(dropDownConfiguration, this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[dropDownConfiguration.id]], this.ExtJSProperties['htmlareacombo']);
 				}
-				if (typeof(dropDownConfiguration.refresh) === "string") {
-					if (typeof(this[dropDownConfiguration.refresh]) === "function") {
-						var refreshFunctionReference = this.makeFunctionReference(dropDownConfiguration.refresh);
-						dropDownConfiguration.refresh = refreshFunctionReference;
-					} else {
-						this.appendToLog("registerDropDown", "Function " + dropDownConfiguration.refresh + " was not defined when registering drop-down " + dropDownConfiguration.id);
-						return false;
-					}
-				}
-				return this.editorConfiguration.registerDropdown(dropDownConfiguration);
+				return this.editorConfiguration.registerButton(dropDownConfiguration);
 			} else {
-				this.appendToLog("registerDropDown", "Function " + dropDownConfiguration.action + " was not defined when registering drop-down " + dropDownConfiguration.id);
+				this.appendToLog('registerDropDown', 'Function ' + dropDownConfiguration.action + ' was not defined when registering drop-down ' + dropDownConfiguration.id);
 			}
 		}
 		return false;
 	},
+	/**
+	 * Registers a text element for inclusion in the toolbar
+	 *
+	 * @param	object		textConfiguration: the configuration object of the text element:
+	 *					id		: unique id for the text item
+	 *					text		: the text litteral
+	 *					tooltip		: tooltip for the text item
+	 *					cls		: a css class to be assigned to the text element
+	 *
+	 * @return	boolean		true if the drop-down list was successfully registered
+	 */
+	registerText: function (textConfiguration) {
+		if (this.isButtonInToolbar(textConfiguration.id)) {
+			textConfiguration.plugins = this;
+			textConfiguration.xtype = 'htmlareatoolbartext';
+			return this.editorConfiguration.registerButton(textConfiguration);
+		}
+		return false;
+	},
 
 	/**
 	 * Returns the drop-down configuration
@@ -2992,7 +3690,7 @@
 	 * @return	object		the drop-down configuration object
 	 */
 	getDropDownConfiguration : function(dropDownId) {
-		return this.editorConfiguration.customSelects[dropDownId];
+		return this.editorConfiguration.buttonsConfig[dropDownId];
 	},
 
 	/**
@@ -3000,19 +3698,13 @@
 	 *
 	 * @param	object		hotKeyConfiguration: the configuration object of the hotkey:
 	 *					id		: the key
-	 *					action		: name of the function invoked when a hotkey is pressed
+	 *					cmd		: name of the button corresponding to the hot key
+	 *					element		: value of the record to be selected in the dropDown item
 	 *
 	 * @return	boolean		true if the hotkey was successfully registered
 	 */
 	registerHotKey : function (hotKeyConfiguration) {
-		if (typeof((hotKeyConfiguration.action) === "string") && (typeof(this[hotKeyConfiguration.action]) === "function")) {
-			var actionFunctionReference = this.makeFunctionReference(hotKeyConfiguration.action);
-			hotKeyConfiguration.action = actionFunctionReference;
-			return this.editorConfiguration.registerHotKey(hotKeyConfiguration);
-		} else {
-			this.appendToLog("registerHotKey", "Function " + hotKeyConfiguration.action + " was not defined when registering hotkey " + hotKeyConfiguration.id);
-			return false;
-		}
+		return this.editorConfiguration.registerHotKey(hotKeyConfiguration);
 	},
 
 	/**
@@ -3041,24 +3733,33 @@
 	 *
 	 * @return	object		the hotkey configuration object
 	 */
-	getHotKeyConfiguration : function(key) {
-		if (typeof(this.editorConfiguration.hotKeyList[key]) !== "undefined") {
+	getHotKeyConfiguration: function(key) {
+		if (Ext.isDefined(this.editorConfiguration.hotKeyList[key])) {
 			return this.editorConfiguration.hotKeyList[key];
 		} else {
 			return null;
 		}
 	},
-
 	/**
+	 * Initializes the plugin
+	 * Is invoked when the toolbar component is created (subclass of Ext.ux.HTMLAreaButton or Ext.ux.form.HTMLAreaCombo)
+	 *
+	 * @param	object		button: the component
+	 *
+	 * @return	void
+	 */
+	init: Ext.emptyFn,
+	/**
 	 * The toolbar refresh handler of the plugin
 	 * This function may be defined by the plugin subclass.
 	 * If defined, the function will be invoked whenever the toolbar state is refreshed.
 	 *
 	 * @return	boolean
 	 */
-	onUpdateToolbar : null,
-
+	onUpdateToolbar: Ext.emptyFn,
 	/**
+	 * Deprecated as of TYPO3 4.4
+	 * Register the key handler to the editor keyMap in onGenerate function
 	 * The keyPress event handler
 	 * This function may be defined by the plugin subclass.
 	 * If defined, the function is invoked whenever a key is pressed.
@@ -3067,20 +3768,8 @@
 	 *
 	 * @return	boolean
 	 */
-	onKeyPress : null,
-
+	onKeyPress: null,
 	/**
-	 * The hotKey event handler
-	 * This function may be defined by the plugin subclass.
-	 * If defined, the function is invoked whenever a hot key is pressed.
-	 *
-	 * @param	event		key: the hot key that was pressed
-	 *
-	 * @return	boolean
-	 */
-	onHotKey : null,
-
-	/**
 	 * The onMode event handler
 	 * This function may be redefined by the plugin subclass.
 	 * The function is invoked whenever the editor changes mode.
@@ -3089,21 +3778,19 @@
 	 *
 	 * @return	boolean
 	 */
-	onMode : function(mode) {
-		if (mode === "textmode" && this.dialog && HTMLArea.Dialog[this.name] == this.dialog && !(this.dialog.buttonId && this.editorConfiguration.btnList[this.dialog.buttonId] && this.editorConfiguration.btnList[this.dialog.buttonId].textMode)) {
+	onMode: function(mode) {
+		if (mode === "textmode" && this.dialog && HTMLArea.Dialog[this.name] == this.dialog && !(this.dialog.buttonId && this.editorConfiguration.buttons[this.dialog.buttonId] && this.editorConfiguration.buttons[this.dialog.buttonId].textMode)) {
 			this.dialog.close();
 		}
 	},
-
 	/**
 	 * The onGenerate event handler
 	 * This function may be defined by the plugin subclass.
-	 * If defined, the function is invoked when the editor is initialized
+	 * The function is invoked when the editor is initialized
 	 *
 	 * @return	boolean
 	 */
-	onGenerate : null,
-
+	onGenerate: Ext.emptyFn,
 	/**
 	 * Make function reference in order to avoid memory leakage in IE
 	 *
@@ -3113,8 +3800,8 @@
 	 */
 	makeFunctionReference : function (functionName) {
 		var self = this;
-		return (function(arg1, arg2) {
-			return (self[functionName](arg1, arg2));});
+		return (function(arg1, arg2, arg3) {
+			return (self[functionName](arg1, arg2, arg3));});
 	},
 
 	/**
